% Numerical tests for the non-periodic approximately sparse case using
% tensor product (preconditioned) Legendre basis in D = 7 spatial dimensions.
% Test function is sum of tensor products of B-Splines of different order.

clear
addpath ../sublin_cosamp_v2
addpath ../fct_bspline_nonperiodic

trial_n = 3;
N_array = 64;
s_array = [10 25]; %[25 50 100 200 500];
m1_fac = 5;
cosamp_max_iter = 20;
tau = 1e-12;

sublin_cosamp_v2_legendrepre_bsplinel7_run(trial_n, N_array, s_array, m1_fac, cosamp_max_iter, tau);

print_legendrepre_bsplinel7_errors
