function out = sublin_cosamp_v2_mixed_m24s_func_noise_run(trial_n, N_array, d_array, s_array, psf_array, sr_array)
%demo file to run the sublinearized CoSaMP ( mixed basis/ Noisy samples)
out = 0;
tau = 0;
cosamp_max_iter = 20;
pairing_type = 'pairing';
basis_type = 'mixed';
L = 0;

if min(d_array) < 6
  error('Please choose d>=6');
end

for N=N_array% the number of possible entries in each dimension
    for d=d_array%the number of dimensions
basis_types = cell(d,1);
for jj=1:d
  basis_types{jj} = 'fourier';
end
basis_types{1} = 'chebyshev';
basis_types{2} = 'legendre_preconditioned';
mid = floor(d/2);
basis_types{mid} = 'legendre_preconditioned';
basis_types{mid+1} = 'chebyshev';
basis_types{end-1} = 'chebyshev';
basis_types{end} = 'legendre_preconditioned';
        for s=s_array%sparsity
          for pairing_sampl_factor = psf_array
            for sr=sr_array %snr in decibel
rng('default');
                fname = ['Stat_N', int2str(N),'_d',int2str(d),'_s',int2str(s),'_snr',int2str(sr),'_pairsamfac',mat2str(pairing_sampl_factor),'_',basis_type,'_sub_v2_m24s_noise_',pairing_type,'.mat'];%file name for statistics
                mean_iter=0;mean_iter_all=0;mean_error_n_all=0;mean_error_c=0;mean_tElapsed_sam=0;...
                    mean_tElapsed_tot=0;success_rate=0;mean_sam_num=0; mean_time_iter=0;%initialization of statistics
                mean_tElapsed_sam_all=0; mean_tElapsed_tot_all=0;
                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                m_ls=50*s;% sample number for the least square problem
                m_1=round(pairing_sampl_factor*s);%sample number m_1 for pairing
                m_2=4*s; %round(2^(d/2)*s);%sample number m_2 for pairing
                m_entryid = [m_1,m_2];
                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                for trial=1:trial_n
                  fprintf('%d %s ', trial, fname);
                  [iter,error_n,error_c,~,~,tElapsed_sam,tElapsed_tot,SF,sam_num]=sublin_cosamp_v2_func_noise(N,d,basis_types,s,m_entryid,L,tau,m_ls,m_1,m_2,cosamp_max_iter,sr,pairing_type);
                    %getting statistics
                    time_iter=tElapsed_tot/iter;
                    mean_error_n_all=mean_error_n_all+error_n;%average error from the support
                    mean_iter_all=mean_iter_all+iter;% average number of iteration
                    if SF==1
                        mean_iter=mean_iter+iter;% average number of iteration
                        mean_error_c=mean_error_c+error_c;%average l_2 error of coefficient vector
                        mean_time_iter=mean_time_iter+time_iter;%average time for each iteration
                        mean_tElapsed_sam=mean_tElapsed_sam+tElapsed_sam;%average time for sampling 
                        mean_tElapsed_tot=mean_tElapsed_tot+tElapsed_tot;%average time for Sublineared CoSaMP
                        success_rate=success_rate+SF;%count successful trials 
                        mean_sam_num=mean_sam_num+sam_num;%average sample number
                    end
                    fprintf('%.3f\n', success_rate/trial);
                        mean_tElapsed_sam_all=mean_tElapsed_sam_all+tElapsed_sam;%average time for sampling 
                        mean_tElapsed_tot_all=mean_tElapsed_tot_all+tElapsed_tot;%average time for Sublineared CoSaMP
               end
                success_num=success_rate;
                mean_iter=mean_iter/success_num;%taking average
                mean_iter_all=mean_iter_all/trial_n;
                mean_error_n_all=mean_error_n_all/trial_n; %taking average
                mean_error_c=mean_error_c/success_num; %taking average
                mean_tElapsed_sam=mean_tElapsed_sam/success_num;%taking average
                mean_tElapsed_tot=mean_tElapsed_tot/success_num;%taking average
                mean_tElapsed_sam_all=mean_tElapsed_sam_all/trial_n;
                mean_tElapsed_tot_all=mean_tElapsed_tot_all/trial_n;
                mean_time_iter=mean_time_iter/success_num; %taking average
                success_rate=success_rate/trial_n; % success rate
                mean_sam_num=mean_sam_num/success_num;%taking average
                save(fname,'N','d','s','mean_iter','mean_iter_all','mean_error_n_all','mean_error_c','mean_tElapsed_sam',...
                    'mean_tElapsed_tot','mean_tElapsed_sam_all','mean_tElapsed_tot_all',...
                    'success_rate','mean_sam_num','mean_time_iter','sr','m_ls','m_entryid','m_1','m_2','trial_n','basis_types');%saving statistics        
            end
          end
        end
    end
end
